<?php
/**
 * JulioReis_CorreiosFollowup
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @category  JulioReis
 * @package   JulioReis_CorreiosFollowup
 *
 * @copyright Copyright (c) 2018 Julio Reis (www.rapidets.com.br)
 *
 * @author    Julio Reis <julioreis.si@gmail.com>
 */

namespace JulioReis\CorreiosFollowup\Model;

use JulioReis\CorreiosFollowup\Model\Config as ModuleConfig;
use Magento\Framework\App\State;
use Magento\Framework\Event\ManagerInterface;
use Magento\Framework\ObjectManagerInterface;
use Magento\Framework\Registry;
use Magento\Store\Model\StoreManagerInterface;
use JulioReis\CorreiosFollowup\Model\Logger\Logger;
use Magento\Framework\App\Config\ScopeConfigInterface;
use JulioReis\CorreiosFollowup\Model\Service as CorreiosService;

class Context implements \Magento\Framework\ObjectManager\ContextInterface
{
    /** @var ModuleConfig */
    private $moduleConfig;

    /** @var StoreManagerInterface */
    private $storeManager;

    /** @var ManagerInterface */
    private $eventManager;

    /** @var ObjectManagerInterface */
    private $objectManager;

    /** @var LoggerInterface */
    private $logger;

    /** @var State */
    private $state;

    /** @var Registry */
    private $registryManager;

    /** @var ScopeConfigInterface */
    private $scopeConfig;

    /** @var CorreiosService */
    private $correiosService;

    /**
     * Context constructor.
     * @param Config $moduleConfig
     * @param StoreManagerInterface $storeManager
     * @param ManagerInterface $eventManager
     * @param Logger $logger
     * @param ObjectManagerInterface $objectManager
     * @param State $state
     * @param Registry $registry
     * @param ScopeConfigInterface $scopeConfig
     * @param Service $correiosService
     */
    public function __construct(
        ModuleConfig $moduleConfig,
        StoreManagerInterface $storeManager,
        ManagerInterface $eventManager,
        Logger $logger,
        ObjectManagerInterface $objectManager,
        State $state,
        Registry $registry,
        ScopeConfigInterface $scopeConfig,
        CorreiosService $correiosService
    ) {
        $this->moduleConfig = $moduleConfig;
        $this->storeManager = $storeManager;
        $this->eventManager = $eventManager;
        $this->objectManager = $objectManager;
        $this->logger = $logger;
        $this->state = $state;
        $this->registryManager = $registry;
        $this->scopeConfig = $scopeConfig;
        $this->correiosService = $correiosService;
    }

    /**
     * @return ManagerInterface
     */
    public function eventManager()
    {
        return $this->eventManager;
    }

    /**
     * @return ObjectManagerInterface
     */
    public function objectManager()
    {
        return $this->objectManager;
    }

    /**
     * @return StoreManagerInterface
     */
    public function storeManager()
    {
        return $this->storeManager;
    }

    /**
     * @return LoggerInterface
     */
    public function logger()
    {
        return $this->logger;
    }

    /**
     * @return State
     */
    public function appState()
    {
        return $this->state;
    }

    public function moduleConfig()
    {
        return $this->moduleConfig;
    }

    /**
     * @return Registry
     */
    public function registryManager()
    {
        return $this->registryManager;
    }

    /**
     * @return ScopeConfigInterface
     */
    public function scopeConfig()
    {
        return $this->scopeConfig;
    }

    /**
     * @return Service
     */
    public function correiosService()
    {
        return $this->correiosService;
    }
}
